WNTR: Water Network Tool for Resilience
=======================================

[![TravisCI](https://travis-ci.org/usepa/wntr.svg?branch=master)](https://travis-ci.org/usepa/wntr)
[![Coverage Status](https://coveralls.io/repos/github/usepa/wntr/badge.svg?branch=master)](https://coveralls.io/github/usepa/wntr?branch=master)
[![Documentation Status](https://readthedocs.org/projects/wntr/badge/?version=latest)](http://wntr.readthedocs.org/en/latest/)

WNTR is a python package designed to simulate and analyze resilience of 
water distribution networks.  The software includes capability to:

* Generate water network models
* Modify network structure and operations
* Add disruptive events including pipe leaks
* Add response/repair strategies
* Simulate pressure driven demand and demand driven hydraulics
* Simulate water quality 
* Evaluate resilience 
* Visualize results



License
------------

WNTR is released under the Revised BSD license.  See the LICENSE.txt file.

WNTR includes pyepanet, a separate python package licensed through Sandia Corporation, copyright 2011.
pyepanet is released under the BSD license.  See wntr/pyepanet/__init__.py

Organization
------------

Directories
  * wntr - The root directory for WNTR source code
  * documentation - user manual
  * examples - examples and network files

Contact
--------

   * Katherine Klise, Sandia National Laboratories, kaklise@sandia.gov
   * Regan Murray, US Environmental Protection Agency, Murray.Regan@epa.gov




